AnimationPlayer = Object:extend()


function AnimationPlayer:new(animation, fps, frameOffset)
  self.fps = fps or animation.fps
  
  self.currentFrame = 1
  self.frameOffset = frameOffset or 0
  if animation == "nil" then
    error("Animation set was nil!")
  end
  self.animation = animation
  self.timePlayed = nil
end


function AnimationPlayer:update(dt)
  if self.timePlayed then
    self.timePlayed = self.timePlayed + dt
    self.currentFrame = math.floor((self.timePlayed*self.fps+self.frameOffset)%#self.animation.frames)+1
  else
    self.currentFrame = 1
  end
end



function AnimationPlayer:play(x, y, r, sx, sy)
  love.graphics.setBlendMode("alpha")
  self.timePlayed = self.timePlayed or 0

  blue.graphics.drawCentredSet(self.animation.frames[self.currentFrame], x, y, r, sx, sy, self.animation.xOffset, self.animation.yOffset)
  
  return self.timePlayed*self.fps >= #self.animation.frames
end



function AnimationPlayer:stop()
  self.timePlayed = nil
end

