Camera = Entity:extend()
local maxZoom = 2.5
local finalZoom = maxZoom
local targetZoom = 0
local effectiveSpeed = 0
local xOffset = 0
local yOffset = -100

function Camera:new(x, y, zoom, targetZoom)
  Entity.super.new(self, x, y)
  self.zoom = maxZoom
  self.type = "camera"
  self.targetZoom = targetZoom*love.graphics.getHeight()/1080
  self.zoomSpeed = 0
  --table.insert(drawTable, self)
end

function Camera:update(dt)
  
  local k = 0.4
  

  local mouseX = mouse.x*k
  local mouseY = mouse.y*k
  
  local playerSpeed = nil
  
  if not player1.stasis then

    playerSpeed = vector.getMagnitude(velocityVector)
    

    effectiveSpeed = moveToward(effectiveSpeed, playerSpeed, math.abs(effectiveSpeed - playerSpeed), dt)

    
    local speed = 0.5
    local reactionTime = 0.5
    local distance = (effectiveSpeed)*reactionTime
    
    
    targetZoom = window.height/2/distance
    

    
    
    if targetZoom > maxZoom then
      targetZoom = maxZoom
    end

    
    if math.abs(finalZoom - targetZoom) < dt*speed then
      finalZoom = targetZoom
    elseif finalZoom < targetZoom then
      finalZoom = finalZoom + dt*speed*finalZoom
    elseif finalZoom > targetZoom then
      finalZoom = finalZoom - dt*speed*finalZoom
    end
    
    if not builderMode then
      local walkOffset = 0
        if player1:canWalk() then
          walkOffset = 100
        end
      
      self.zoom = finalZoom
      xOffset = moveToward(xOffset, mouseX, math.abs(mouseX - xOffset), dt)
      yOffset = moveToward(yOffset, mouseY-walkOffset, math.abs(mouseY-walkOffset - yOffset), dt)
      
      self.x, self.y = player1.body:getPosition( )
      self.x = (self.x + xOffset/self.zoom) * -1
      self.y = (self.y + yOffset/self.zoom) * -1
    
    end
  end
  
end

function Camera:draw()
  local proposedZoom = 1/2
  love.graphics.setColor(1,1,1)
  blue.graphics.rectangle("line", camera.x*-1 - window.width/2/finalZoom + xOffset, camera.y*-1 - window.height/2/finalZoom + yOffset,  window.width/finalZoom, window.height/finalZoom)
  
  
  love.graphics.setColor(0,1,0)
  blue.graphics.rectangle("line", camera.x*-1 - window.width/2/targetZoom + xOffset, camera.y*-1 - window.height/2/targetZoom + yOffset,  window.width/targetZoom, window.height/targetZoom)

  blue.graphics.circle("line", player1.body:getX(), player1.body:getY(), distance)
  
end


function moveToward(number, target, speed, dt)
  
  if speed < 2 then
    speed = 2
  end
  
  if math.abs(number - target) < speed*dt then
    return target
  elseif number < target then
    return number + dt*speed
  else 
    return number - dt*speed
  end
  
end