function beginContact(a, b, coll)
  if a:getUserData() == "sensor" or b:getUserData() == "sensor" then
    groundSensor.triggered = true
  end
end

function endContact(a, b, coll)
  player1.collisionTable[a] = nil
  player1.collisionTable[b] = nil
end


function postSolve(a, b, coll, normalimpulse, tangentimpulse)
 
	if a:getUserData() == "player" or b:getUserData() == "player" then
    
    if normalimpulse > 80 then
      sound.effect.thud:setVolume((normalimpulse-60)/200)
      sound.effect.thud:play()
    end
    
    local notPlayer
    local player
    
    if a:getUserData() == "player" then
      notPlayer = b
      player = a
    else
      notPlayer = a
      player = b
    end
    player1.collisionImpulse = normalimpulse
    
    
    local nx, ny = coll:getNormal( )
  
    local normalVector = vector.create(nx, ny)
    table.insert(player1.collisionTable, normalVector)
      

  elseif (a:getUserData() and a:getUserData().type == "sword") or (b:getUserData() and b:getUserData().type == "sword") then
    local sword = nil
    if (a:getUserData() and a:getUserData().type == "sword") then
      sword = a:getUserData()
      if not sword.locked then
        sword.lockedBody = b:getBody()
      end
    end
    if (b:getUserData() and b:getUserData().type == "sword") then
      sword = b:getUserData()
      if not sword.locked then
        sword.lockedBody = a:getBody()
      end
    end

    sword.locked = true
    
    
  elseif (a:getUserData() and a:getUserData().type == "fireball")  then
    a:getUserData().collided = true
  elseif (b:getUserData() and b:getUserData().type == "fireball") then
    b:getUserData().collided = true
  end
  
  --[[if a:getUserData() and a:getUserData().storeSlowmoValues then
    
    print(a:getUserData().storeSlowmoValues)
    a:getUserData():storeSlowmoValues()
  end
  
  if b:getUserData() and b:getUserData().storeSlowmoValues then
    b:getUserData():storeSlowmoValues()
  end]]
  
end


function Player:getCollisionVectors()
  
  local numberOfEntries = 0
  for i, v in ipairs(player1.collisionTable) do
    numberOfEntries = numberOfEntries + 1
  end
  if numberOfEntries > 0 then
    self.contactWithGround = true
  else
    self.contactWithGround = false
    return
  end
  local trueAverageNormal = vector.create(0,0)
  local averageNormal = vector.create(0,0)
  local averageVelocity = vector.create(0, 0)
  for i, v in pairs(self.collisionTable) do
    trueAverageNormal = vector.addition(averageNormal, v)
    --Check to see if the surfaces are valid for walking on
    if self:canWalkPart(v) then
      averageNormal = vector.addition(averageNormal, v)
      --averageVelocity = vector.addition(averageVelocity, vector.scalarMultiplication(vector.create(i:getBody():getLinearVelocity()), 1/numberOfEntries))
    end
  end
  trueAverageNormal = vector.normalize(trueAverageNormal)
  averageNormal = vector.normalize(averageNormal)
  
  self.tangentWithGround = vector.turn90Degrees(vector.normalize(averageNormal))
  local relativeVelocity = vector.subtraction(self.velocityLastFrame, averageNormal)
  self.tangentVelocity = vector.project(relativeVelocity, player1.tangentWithGround)
  self.walkableNormalVelocity = vector.project(relativeVelocity, averageNormal)
  self.normalVelocity = vector.project(relativeVelocity, trueAverageNormal)
  self.normalWithGround = averageNormal
  
end


function Player:clearCollisionTable()
  
  self.collisionTable = {}
end


